using System;
using System.Collections.Generic;
using System.Text;

namespace DcartesClassLibrary
{
    #region TipoFiltro
    public enum TipoFiltro
    {
        Data = 'D',
        Numero = 'N',
        Texto = 'T'
    }
    #endregion

    #region TipoArea
    public enum TipoArea
    {
        Menu = 'M',
        Guia = 'G',
        Resumo = 'R'
    }
    #endregion

    #region TipoConta
    public enum TipoConta
    {
        Receita = 'R',
        Despesa = 'D'
    }
    #endregion

    #region TipoRateio
    public enum TipoRateio
    {
        Peso = 'P',
        Livre = 'L',
        DivisaoPercentual = 'D'
    }
    #endregion

    #region TipoClassificacaoConta
    public enum TipoClassificacaoConta
    {
        Fixo = 'F',
        Variavel = 'V'
    }
    #endregion

    #region TipoBancoCaixa
    public enum TipoBancoCaixa
    {
        Banco = 'B',
        Caixa = 'C'
    }
    #endregion

    #region TipoClienteFornecedor
    public enum TipoClienteFornecedor
    {
        Cliente = 'C',
        Fornecedor = 'F',
        Ambos = 'A'
    }
    #endregion

    #region TipoFisicoJuridico
    public enum TipoFisicoJuridico
    {
        Fisico = 'F',
        Juridico = 'J'
    }
    #endregion

    #region TipoLancamentoConta
    public enum TipoLancamentoConta
    {
        ContaAReceber = 'R',
        ContaAPagar = 'P'
    }
    #endregion

    #region TipoLancamentoVista
    public enum TipoLancamentoVista
    {
        PorDocumento = 'D',
        PorRecurso = 'R'
    }
    #endregion

    #region TipoLancamento
    public enum TipoLancamento
    {
        ReceberPrazoValorDoc,   // RPV
        ReceberPrazoJuros,      // RPJ
        ReceberPrazoMulta,      // RPM
        ReceberVista,           // RVI
        PagarPrazoValorDoc,     // PPV
        PagarPrazoJuros,        // PPJ
        PagarPrazoMulta,        // PPM
        PagarVista,             // PVI
        BaixoCaixa              // LCT
    }
    #endregion

    #region TipoAcesso
    public enum TipoAcesso
    {
        SemAcesso  = 'S',
        Consulta   = 'C',
        Manutencao = 'M'
    }
    #endregion

    #region TipoOperacao
    public enum TipoOperacao
    {
        Credito = 'C',
        Debito = 'D',
        Todas = 'T'
    }
    #endregion

    #region TipoEquipe
    public enum TipoEquipe
    {
        Motorista = 'M',
        Ajudante = 'A',
        Outros = 'O'
    }
    #endregion
    
    #region TipoOperacaoEstoque
    public enum TipoMovimentacao
    {
        Entrada = 'E',
        Saida = 'S'
    }
    #endregion

    #region StatusLigacao
    public enum StatusLigacao
    {
        Efetivada = 'E',
        NaoEfetivada = 'N'
    }
    #endregion

    #region PosicaoAcento
    public enum PosicaoAcento
    {
        Normal = 'N',
        Invertido = 'I',
        Reversivel = 'R'
    }
    #endregion

    #region ComposicaoSentido
    public enum ComposicaoSentido
    {
        Normal = 'N',
        Invertido = 'I'
    }
    #endregion

    #region TipoVenda
    public enum TipoVenda
    {
        Balcao = 'B',
        Web = 'W',
        Agencia = 'A'
    }
    #endregion

    #region TipoEntidade
    public enum TipoEntidade
    {
        Operadora = 'O',
        Representante = 'R',
        Agencia = 'A',
        GuiaTuristico = 'G',
        Pai = 'P',
        Todas = 'T'
    }
    #endregion

    #region TipoMascara
    public enum TipoMascara
    {
        DATA = 'D',
        NUMERO = 'N',
        HORA = 'H',
        CEP = 'C',
        PLACA = 'P',
        CPF = 'P',
        CNPJ = 'J',
        VALOR = 'V'
    }
    #endregion

}
