-- ***************************************************************************************************************************************************
-- Autor..............: Joel Ferreira
-- Data...............: 10/07/2008
-- Classe do sistema..: Campanha
-- ***************************************************************************************************************************************************

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'spCampanhaSel')
	BEGIN
		PRINT 'Dropping Procedure spCampanhaSel'
		DROP PROCEDURE spCampanhaSel
	END
GO

CREATE PROCEDURE spCampanhaSel (
	@codigoCam INT = null,
	@codigoAna INT = null,
	@nomeCam VARCHAR(100) = null,
	@inicioValidadeCam DATETIME = null,
	@fimValidadeCam DATETIME = null,
	@inicioContagemPedidosCam DATETIME = null,
	@fimContagemPedidosCam DATETIME = null,
	@scriptMonitorCam BIT = null,
	@listarEmailsCam BIT = null)
AS

DECLARE @sql varchar(8000)

SET @sql = ' 
	SELECT 
		codigoCam,
		codigoAna,
		nomeCam,
		inicioValidadeCam,
		fimValidadeCam,
		inicioContagemPedidosCam,
		fimContagemPedidosCam,
		scriptMonitorCam,
		listarEmailsCam
	FROM Campanha
	WHERE 1 = 1'

IF (@codigoCam IS NOT NULL)
	SET @sql = @sql + ' AND codigoCam = ' + CONVERT(VARCHAR,@codigoCam)

IF (@codigoAna IS NOT NULL)
	SET @sql = @sql + ' AND codigoAna = ' + CONVERT(VARCHAR,@codigoAna)

IF (@nomeCam IS NOT NULL)
	SET @sql = @sql + ' AND nomeCam LIKE ''%' + @nomeCam + '%'''

IF (@inicioValidadeCam IS NOT NULL)
	SET @sql = @sql + ' AND inicioValidadeCam = ''' + CONVERT(VARCHAR,@inicioValidadeCam) + ''''

IF (@fimValidadeCam IS NOT NULL)
	SET @sql = @sql + ' AND fimValidadeCam = ''' + CONVERT(VARCHAR,@fimValidadeCam) + ''''

IF (@inicioContagemPedidosCam IS NOT NULL)
	SET @sql = @sql + ' AND inicioContagemPedidosCam = ''' + CONVERT(VARCHAR,@inicioContagemPedidosCam) + ''''

IF (@fimContagemPedidosCam IS NOT NULL)
	SET @sql = @sql + ' AND fimContagemPedidosCam = ''' + CONVERT(VARCHAR,@fimContagemPedidosCam) + ''''

IF (@scriptMonitorCam IS NOT NULL)
	SET @sql = @sql + ' AND scriptMonitorCam = ' + CONVERT(VARCHAR,@scriptMonitorCam)

IF (@listarEmailsCam IS NOT NULL)
	SET @sql = @sql + ' AND listarEmailsCam = ' + CONVERT(VARCHAR,@listarEmailsCam)

PRINT(@sql)
EXECUTE(@sql)

GO