-- ***************************************************************************************************************************************************
-- Autor..............: Joel Ferreira
-- Data...............: 10/07/2008
-- Classe do sistema..: Endereco
-- ***************************************************************************************************************************************************

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'spEnderecoSel')
	BEGIN
		PRINT 'Dropping Procedure spEnderecoSel'
		DROP PROCEDURE spEnderecoSel
	END
GO

CREATE PROCEDURE spEnderecoSel (
	@codigoEnd INT = null,
	@logradouroEnd VARCHAR(250) = null,
	@numeroEnd VARCHAR(20) = null,
	@complementoEnd VARCHAR(40) = null,
	@bairroEnd VARCHAR(100) = null,
	@municipioEnd VARCHAR(100) = null,
	@ufEnd VARCHAR(20) = null,
	@cepEnd VARCHAR(8) = null,
	@regiaoEnd VARCHAR(100) = null,
	@paisEnd VARCHAR(100) = null,
	@caixaPostalEnd VARCHAR(20) = null)
AS

DECLARE @sql varchar(8000)

SET @sql = ' 
	SELECT 
		codigoEnd,
		logradouroEnd,
		numeroEnd,
		complementoEnd,
		bairroEnd,
		municipioEnd,
		ufEnd,
		cepEnd,
		regiaoEnd,
		paisEnd,
		caixaPostalEnd
	FROM Endereco
	WHERE 1 = 1'

IF (@codigoEnd IS NOT NULL)
	SET @sql = @sql + ' AND codigoEnd = ' + CONVERT(VARCHAR,@codigoEnd)

IF (@logradouroEnd IS NOT NULL)
	SET @sql = @sql + ' AND logradouroEnd LIKE ''%' + @logradouroEnd + '%'''

IF (@numeroEnd IS NOT NULL)
	SET @sql = @sql + ' AND numeroEnd LIKE ''%' + @numeroEnd + '%'''

IF (@complementoEnd IS NOT NULL)
	SET @sql = @sql + ' AND complementoEnd LIKE ''%' + @complementoEnd + '%'''

IF (@bairroEnd IS NOT NULL)
	SET @sql = @sql + ' AND bairroEnd LIKE ''%' + @bairroEnd + '%'''

IF (@municipioEnd IS NOT NULL)
	SET @sql = @sql + ' AND municipioEnd LIKE ''%' + @municipioEnd + '%'''

IF (@ufEnd IS NOT NULL)
	SET @sql = @sql + ' AND ufEnd LIKE ''%' + @ufEnd + '%'''

IF (@cepEnd IS NOT NULL)
	SET @sql = @sql + ' AND cepEnd LIKE ''%' + @cepEnd + '%'''

IF (@regiaoEnd IS NOT NULL)
	SET @sql = @sql + ' AND regiaoEnd LIKE ''%' + @regiaoEnd + '%'''

IF (@paisEnd IS NOT NULL)
	SET @sql = @sql + ' AND paisEnd LIKE ''%' + @paisEnd + '%'''

IF (@caixaPostalEnd IS NOT NULL)
	SET @sql = @sql + ' AND caixaPostalEnd LIKE ''%' + @caixaPostalEnd + '%'''

PRINT(@sql)
EXECUTE(@sql)

GO