-- ***************************************************************************************************************************************************
-- Autor..............: Joel Ferreira
-- Data...............: 10/07/2008
-- Classe do sistema..: Loja
-- ***************************************************************************************************************************************************

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'spLojaSel')
	BEGIN
		PRINT 'Dropping Procedure spLojaSel'
		DROP PROCEDURE spLojaSel
	END
GO

CREATE PROCEDURE spLojaSel (
	@codigoLoj INT = null,
	@codigoEMa INT = null,
	@codigoSMe INT = null,
	@codigoEnd INT = null,
	@cnpjLoj VARCHAR(20) = null,
	@inscEstadualLoj VARCHAR(20) = null,
	@dataAberturaLoj DATETIME = null,
	@razaoSocialLoj VARCHAR(100) = null,
	@telefoneLoj VARCHAR(20) = null,
	@faxLoj VARCHAR(20) = null,
	@emailLoj VARCHAR(100) = null,
	@senhaLoj VARCHAR(250) = null,
	@provedorLoj VARCHAR(100) = null,
	@responsavelDominioLoj VARCHAR(250) = null,
	@urlDominioLoj VARCHAR(100) = null,
	@criacaoDominioLoj DATETIME = null,
	@expiracaoDominioLoj DATETIME = null)
AS

DECLARE @sql varchar(8000)

SET @sql = ' 
	SELECT 
		codigoLoj,
		codigoEMa,
		codigoSMe,
		codigoEnd,
		cnpjLoj,
		inscEstadualLoj,
		dataAberturaLoj,
		razaoSocialLoj,
		telefoneLoj,
		faxLoj,
		emailLoj,
		senhaLoj,
		provedorLoj,
		responsavelDominioLoj,
		urlDominioLoj,
		criacaoDominioLoj,
		expiracaoDominioLoj
	FROM Loja
	WHERE 1 = 1'

IF (@codigoLoj IS NOT NULL)
	SET @sql = @sql + ' AND codigoLoj = ' + CONVERT(VARCHAR,@codigoLoj)

IF (@codigoEMa IS NOT NULL)
	SET @sql = @sql + ' AND codigoEMa = ' + CONVERT(VARCHAR,@codigoEMa)

IF (@codigoSMe IS NOT NULL)
	SET @sql = @sql + ' AND codigoSMe = ' + CONVERT(VARCHAR,@codigoSMe)

IF (@codigoEnd IS NOT NULL)
	SET @sql = @sql + ' AND codigoEnd = ' + CONVERT(VARCHAR,@codigoEnd)

IF (@cnpjLoj IS NOT NULL)
	SET @sql = @sql + ' AND cnpjLoj LIKE ''%' + @cnpjLoj + '%'''

IF (@inscEstadualLoj IS NOT NULL)
	SET @sql = @sql + ' AND inscEstadualLoj LIKE ''%' + @inscEstadualLoj + '%'''

IF (@dataAberturaLoj IS NOT NULL)
	SET @sql = @sql + ' AND dataAberturaLoj = ''' + CONVERT(VARCHAR,@dataAberturaLoj) + ''''

IF (@razaoSocialLoj IS NOT NULL)
	SET @sql = @sql + ' AND razaoSocialLoj LIKE ''%' + @razaoSocialLoj + '%'''

IF (@telefoneLoj IS NOT NULL)
	SET @sql = @sql + ' AND telefoneLoj LIKE ''%' + @telefoneLoj + '%'''

IF (@faxLoj IS NOT NULL)
	SET @sql = @sql + ' AND faxLoj LIKE ''%' + @faxLoj + '%'''

IF (@emailLoj IS NOT NULL)
	SET @sql = @sql + ' AND emailLoj LIKE ''%' + @emailLoj + '%'''

IF (@senhaLoj IS NOT NULL)
	SET @sql = @sql + ' AND senhaLoj LIKE ''%' + @senhaLoj + '%'''

IF (@provedorLoj IS NOT NULL)
	SET @sql = @sql + ' AND provedorLoj LIKE ''%' + @provedorLoj + '%'''

IF (@responsavelDominioLoj IS NOT NULL)
	SET @sql = @sql + ' AND responsavelDominioLoj LIKE ''%' + @responsavelDominioLoj + '%'''

IF (@urlDominioLoj IS NOT NULL)
	SET @sql = @sql + ' AND urlDominioLoj LIKE ''%' + @urlDominioLoj + '%'''

IF (@criacaoDominioLoj IS NOT NULL)
	SET @sql = @sql + ' AND criacaoDominioLoj = ''' + CONVERT(VARCHAR,@criacaoDominioLoj) + ''''

IF (@expiracaoDominioLoj IS NOT NULL)
	SET @sql = @sql + ' AND expiracaoDominioLoj = ''' + CONVERT(VARCHAR,@expiracaoDominioLoj) + ''''

PRINT(@sql)
EXECUTE(@sql)

GO