-- ***************************************************************************************************************************************************
-- Autor..............: Joel Ferreira
-- Data...............: 10/07/2008
-- Classe do sistema..: Pedido
-- ***************************************************************************************************************************************************

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'spPedidoIns')
	BEGIN
		PRINT 'Dropping Procedure spPedidoIns'
		DROP PROCEDURE spPedidoIns
	END
GO

CREATE PROCEDURE spPedidoIns (
	@codigoPed INT OUTPUT,
	@codigoVCo INT,
	@codigoTra INT,
	@codigoPar INT,
	@codigoMPa INT,
	@codigoLoj INT,
	@codigoCon INT,
	@referenciaPed VARCHAR(50),
	@dataPed DATETIME,
	@numParcelasPed INT,
	@valorFretePed MONEY,
	@valorTotalIPePed MONEY)
AS

INSERT INTO Pedido(
	codigoVCo,
	codigoTra,
	codigoPar,
	codigoMPa,
	codigoLoj,
	codigoCon,
	referenciaPed,
	dataPed,
	numParcelasPed,
	valorFretePed,
	valorTotalIPePed)
VALUES (
	@codigoVCo,
	@codigoTra,
	@codigoPar,
	@codigoMPa,
	@codigoLoj,
	@codigoCon,
	@referenciaPed,
	@dataPed,
	@numParcelasPed,
	@valorFretePed,
	@valorTotalIPePed)

SET @codigoPed = @@IDENTITY

GO