-- ***************************************************************************************************************************************************
-- Autor..............: Joel Ferreira
-- Data...............: 10/07/2008
-- Classe do sistema..: Pedido
-- ***************************************************************************************************************************************************

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'spPedidoSel')
	BEGIN
		PRINT 'Dropping Procedure spPedidoSel'
		DROP PROCEDURE spPedidoSel
	END
GO

CREATE PROCEDURE spPedidoSel (
	@codigoPed INT = null,
	@codigoVCo INT = null,
	@codigoTra INT = null,
	@codigoPar INT = null,
	@codigoMPa INT = null,
	@codigoLoj INT = null,
	@codigoCon INT = null,
	@referenciaPed VARCHAR(50) = null,
	@dataPed DATETIME = null,
	@numParcelasPed INT = null,
	@valorFretePed MONEY = null,
	@valorTotalIPePed MONEY = null)
AS

DECLARE @sql varchar(8000)

SET @sql = ' 
	SELECT 
		codigoPed,
		codigoVCo,
		codigoTra,
		codigoPar,
		codigoMPa,
		codigoLoj,
		codigoCon,
		referenciaPed,
		dataPed,
		numParcelasPed,
		valorFretePed,
		valorTotalIPePed
	FROM Pedido
	WHERE 1 = 1'

IF (@codigoPed IS NOT NULL)
	SET @sql = @sql + ' AND codigoPed = ' + CONVERT(VARCHAR,@codigoPed)

IF (@codigoVCo IS NOT NULL)
	SET @sql = @sql + ' AND codigoVCo = ' + CONVERT(VARCHAR,@codigoVCo)

IF (@codigoTra IS NOT NULL)
	SET @sql = @sql + ' AND codigoTra = ' + CONVERT(VARCHAR,@codigoTra)

IF (@codigoPar IS NOT NULL)
	SET @sql = @sql + ' AND codigoPar = ' + CONVERT(VARCHAR,@codigoPar)

IF (@codigoMPa IS NOT NULL)
	SET @sql = @sql + ' AND codigoMPa = ' + CONVERT(VARCHAR,@codigoMPa)

IF (@codigoLoj IS NOT NULL)
	SET @sql = @sql + ' AND codigoLoj = ' + CONVERT(VARCHAR,@codigoLoj)

IF (@codigoCon IS NOT NULL)
	SET @sql = @sql + ' AND codigoCon = ' + CONVERT(VARCHAR,@codigoCon)

IF (@referenciaPed IS NOT NULL)
	SET @sql = @sql + ' AND referenciaPed LIKE ''%' + @referenciaPed + '%'''

IF (@dataPed IS NOT NULL)
	SET @sql = @sql + ' AND dataPed = ''' + CONVERT(VARCHAR,@dataPed) + ''''

IF (@numParcelasPed IS NOT NULL)
	SET @sql = @sql + ' AND numParcelasPed = ' + CONVERT(VARCHAR,@numParcelasPed)

IF (@valorFretePed IS NOT NULL)
	SET @sql = @sql + ' AND valorFretePed = ' + CONVERT(VARCHAR,@valorFretePed)

IF (@valorTotalIPePed IS NOT NULL)
	SET @sql = @sql + ' AND valorTotalIPePed = ' + CONVERT(VARCHAR,@valorTotalIPePed)

PRINT(@sql)
EXECUTE(@sql)

GO