-- ***************************************************************************************************************************************************
-- Autor..............: Joel Ferreira
-- Data...............: 05/08/2008
-- Classe do sistema..: Pedido
-- ***************************************************************************************************************************************************

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'spPedidoSelMeta')
	BEGIN
		DROP  Procedure  spPedidoSelMeta
	END

GO

CREATE Procedure spPedidoSelMeta
(
	@codigoLoj int,				--Cdigo da Loja
	@codigoPPeConcluido int,	--Cdigo de PassoPedido Concludo(s vai trazer os pedidos que j esto concludos), o cdigo atual  o 6 
	@tipoPeriodo char(1),		--Enumerador TipoPeriodo, pode ser Anual, Mensal ou Semanal
	@periodoInicial datetime,	--Perodo Inicial (para Mensal  o primeiro dia do ms, para Anual  s o nmero do ano, para Semanal  o primeiro dia da semana)
	@periodoFinal datetime		--Perodo Inicial (para Mensal  o ltimo dia do ms, para Anual  s o nmero do ano, para Semanal  o primeiro dia da semana
)

AS

DECLARE @dataAux datetime
DECLARE @sqlSub varchar(8000)
DECLARE @sql varchar(8000)
DECLARE @sqlInsert varchar(8000)

CREATE TABLE #tempTableXml
(
	fieldXml xml NOT NULL 
)

CREATE TABLE #tempTableDatas
(
	data varchar(100) NOT NULL
)

SET language portuguese
SET @dataAux = @periodoInicial

WHILE (@dataAux <= @periodoFinal)
BEGIN 
	IF (@tipoPeriodo = 'A')
		BEGIN 
			INSERT INTO #tempTableDatas VALUES (datepart(yy, @dataAux))
			SET @dataAux = dateadd(yy, 1, @dataAux)
		END 

	IF (@tipoPeriodo = 'M')
		BEGIN 
			INSERT INTO #tempTableDatas VALUES (datename(mm, @dataAux) + '/' + convert(varchar, datepart(yy, @dataAux)))
			SET @dataAux = dateadd(mm, 1, @dataAux)
		END

	IF (@tipoPeriodo = 'S')
		BEGIN 
			INSERT INTO #tempTableDatas VALUES (@dataAux)
			SET @dataAux = dateadd(dd, 7, @dataAux)
		END
END

IF (@tipoPeriodo = 'A')
	SET @sqlSub = 'SELECT s.anoPed as data, m.valorMet, SUM(s.valorTotalPed) as somaPed FROM'

IF (@tipoPeriodo = 'M')
	SET @sqlSub = 'SELECT s.mesPed as data, m.valorMet, SUM(s.valorTotalPed) as somaPed FROM'

IF (@tipoPeriodo = 'S')
	SET @sqlSub = 'SELECT s.semanaPed as data, m.valorMet, SUM(s.valorTotalPed) as somaPed FROM'

SET @sqlSub = @sqlSub + '
	(SELECT 
		datepart(yy, p.dataPed) AS anoPed,
		datename(mm, p.dataPed) + ''/'' + convert(varchar, datepart(yy, p.dataPed)) AS mesPed,
		CASE datepart(dw, p.dataPed)
			WHEN 1 THEN p.dataPed
			WHEN 2 THEN dateadd(dd, -1, p.dataPed)
			WHEN 3 THEN dateadd(dd, -2, p.dataPed)
			WHEN 4 THEN dateadd(dd, -3, p.dataPed)
			WHEN 5 THEN dateadd(dd, -4, p.dataPed)
			WHEN 6 THEN dateadd(dd, -5, p.dataPed)
			WHEN 7 THEN dateadd(dd, -6, p.dataPed)
		END AS semanaPed,
		p.dataPed,
		p.valorTotalPed
	FROM Pedido p INNER JOIN Loja l ON p.codigoLoj = l.codigoLoj
	INNER JOIN HistoricoPedido h ON h.codigoPed = p.codigoPed AND h.codigoPPe = ' + convert(varchar, @codigoPPeConcluido) + '
	WHERE l.codigoLoj = ' + convert(varchar, @codigoLoj) + '
	AND p.dataPed BETWEEN ''' + convert(varchar, @periodoInicial) + ''' AND ''' + convert(varchar, @periodoFinal) + '''
	) AS s
	INNER JOIN
	(
		SELECT 
		meta.valorMet,
		meta.periodoInicialMet,
		meta.periodoFinalMet
		FROM meta 
		WHERE periodoInicialMet BETWEEN ''' + convert(varchar, @periodoInicial) + ''' AND ''' + convert(varchar, @periodoFinal) + '''
		AND meta.tipoPeriodoMet = ''' + convert(varchar, @tipoPeriodo) + '''
	) as m ON '

IF (@tipoPeriodo = 'A')
	SET @sqlSub = @sqlSub + 's.anoPed = datepart(yy, m.periodoInicialMet) 
		AND s.anoPed = datepart(yy, m.periodoFinalMet) 
		GROUP BY s.anoPed, m.valorMet'

IF (@tipoPeriodo = 'M')
	SET @sqlSub = @sqlSub + 's.mesPed = datename(mm, m.periodoInicialMet) + ''/'' + convert(varchar, datepart(yy, m.periodoInicialMet))
		AND s.mesPed = datename(mm, m.periodoFinalMet) + ''/'' + convert(varchar, datepart(yy, m.periodoFinalMet)) 
		GROUP BY s.mesPed, m.valorMet'

IF (@tipoPeriodo = 'S')
	SET @sqlSub = @sqlSub + 's.semanaPed = m.periodoInicialMet 
		AND s.semanaPed = m.periodoFinalMet 
		GROUP BY s.semanaPed, m.valorMet'

SET @sql = 
	'SELECT 
		t.data,
		CASE
			WHEN s.valorMet IS NOT NULL THEN s.valorMet
			ELSE 0
		END AS valorMet,
		CASE
			WHEN s.somaPed IS NOT NULL THEN s.somaPed
			ELSE 0
		END AS somaPed
	FROM (' + @sqlSub + ')as s RIGHT JOIN #tempTableDatas t ON t.data = s.data'

SET @sqlInsert = 
	'INSERT INTO #tempTableXml SELECT
	(SELECT RTRIM(s.data) AS ''@label'' FROM (' + @sql + ') as s
	FOR XML PATH(''category''), ROOT(''categories''), TYPE)'
EXECUTE (@sqlInsert)

SET @sqlInsert =
	'INSERT INTO #tempTableXml SELECT
	(SELECT RTRIM(s.valorMet) AS ''@value'' FROM (' + @sql + ') as s
	FOR XML PATH(''set''), ROOT(''dataSet''), TYPE)'
EXECUTE (@sqlInsert)

SET @sqlInsert =
	'INSERT INTO #tempTableXml SELECT
	(SELECT RTRIM(s.somaPed) AS ''@value'' FROM (' + @sql + ') as s
	FOR XML PATH(''set''), ROOT(''dataSet''), TYPE)'
EXECUTE (@sqlInsert)

SELECT * FROM #tempTableXml
GO 