-- ***************************************************************************************************************************************************
-- Sistema......................: DCartes
-- Autor........................: Jesiel Sopzak Campos
-- Data.........................: 07/09/2008 10:46
-- Classe do sistema............: GraficoDC
-- ***************************************************************************************************************************************************

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'spTicketMedioSel')
	BEGIN
		PRINT 'Dropping Procedure spTicketMedioSel'
		DROP  PROCEDURE  spTicketMedioSel
	END
GO

CREATE PROCEDURE spTicketMedioSel (
	@dtaDe datetime,
	@dtaAte datetime,
	@tipo varchar(1),
	@CodLoja int )
AS


declare @dtaMax dateTime

CREATE TABLE #tempTable
(
	valor int not null,
	tempo datetime not null
)

if(@tipo = 'D')--Se for Diarias
Begin
	set @dtaMax = @dtaDe
	
	while(@dtaMax <= @dtaAte)
	Begin
		insert into #tempTable SELECT 0,@dtaMax
		Set @dtaMax = (SELECT DATEADD(DAY,1,@dtaMax)) 
	End
	select distinct sum(valor),tempo from (select * from #tempTable
	Union
	Select (isnull(sum(valorTotalPed - valorFretePed),0)/isnull(count(dataPed),1)) as valor,  dataPed
	from Pedido 
	where @dtaDe <= dataPed and @dtaAte >= dataPed and codigoloj = @CodLoja
	group by dataPed	) as tbl group by tempo
END					
if(@tipo = 'M')--Se for Diarias
Begin
	set @dtaMax = @dtaDe
	
	while(@dtaMax <= @dtaAte)
	Begin
		insert into #tempTable SELECT 0,@dtaMax
		Set @dtaMax = (SELECT DATEADD(MONTH,1,@dtaMax)) 
	End
	select distinct sum(valor), tempo from (
	select valor as valor, convert(varchar,MONTH(tempo))+'/'+convert(varchar,year(tempo)) as tempo, year(tempo)  as tempoY from #tempTable
	Union
	Select (isnull(sum(valorTotalPed - valorFretePed),0)/isnull(count(dataPed),1)) as valor,
	  convert(varchar,MONTH(dataPed))+'/'+convert(varchar,year(dataPed)) as tempo, year(dataPed) as tempoY
	from Pedido 
	where @dtaDe <= dataPed and @dtaAte >= dataPed and codigoloj = @CodLoja
	group by convert(varchar,MONTH(dataPed))+'/'+convert(varchar,year(dataPed)), year(dataPed)
	) as tbl group by tempo
END					
if(@tipo = 'A')--Se for Anual
Begin
	set @dtaMax = @dtaDe
	
	while(@dtaMax <= @dtaAte)
	Begin
		insert into #tempTable SELECT 0,@dtaMax
		Set @dtaMax = (SELECT DATEADD(Year,1,@dtaMax)) 
	End
	select distinct sum(valor), tempo from (
	select valor as valor, convert(varchar,Year(tempo)) as tempo from #tempTable
	Union
	Select (isnull(sum(valorTotalPed - valorFretePed),0)/isnull(count(dataPed),1)) as valor,
	  convert(varchar,year(dataPed)) as tempo	from Pedido 
	where @dtaDe <= dataPed and @dtaAte >= dataPed and codigoloj = @CodLoja
	group by convert(varchar,year(dataPed))
	) as tbl group by tempo
END					


GO
 