using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using InfoSoftGlobal;
using DcartesClassLibrary;
using System.Collections.Generic;

public partial class DeshBoard : Sistema_Template_TelaPadrao
{
    #region Tabela
    /// <summary>
    /// Tabel que alimenta a grid
    /// </summary>
    public DataTable Tabela
    {
        get
        {
            if (ViewState["tabela"] == null)
            {
                DataTable tabela = new DataTable();
                tabela.Columns.Add("codigoDashBoard");
                tabela.Columns.Add("Xml");
                tabela.Columns.Add("Index");
                tabela.Columns.Add("Chart");
                tabela.Columns.Add("Nome");
                ViewState.Add("tabela", tabela);
                return tabela;
            }
            else
            {
                return (DataTable)(ViewState["tabela"]);
            }
        }
        set
        {
            ViewState.Add("tabela", value);
        }
    }
    #endregion

    #region PageLoadTemplate
    public override void PageLoadTemplate()
    {
        carregaGrid();
        if (!IsPostBack)
        {
            divPeriodo.Visible = false;
            divTiquet.Visible = false;
            divMeta.Visible = false;
            //preenchendo a Tabela com os Grficos
            if (ViewState["tabela"] != null)
            {
                try
                {
                    #region Carregando DashBoard
                    SqlDataReader dreader = DashBoard.LoadDataReaderLoja(CodigoLojaSessao);
                    while (dreader.Read())
                    {
                        if (dreader["funcao"].ToString() == "T")//Tiquet Mdio
                        {
                            #region xml de Tiquet
                            string cabecalho = @"<chart bgColor='FFFFFF' 
                showBorder='0' 
                showvalues='0' 
                caption='Ticket Mdio' 
                decimalprecision='2' 
                palette='3' numberPreffix='R$ '
                useRoundEdges='0'>";
                            string categories = "<categories>";
                            string dataSet = "<dataSet >";
                            string dataSet2 = "<dataSet >";
                            string valor = "";//Auxiliar
                            string rodape = @"<styles>
                    <definition>
                        <style name='CaptionStyle' type='font' font='Arial' size='16' color='00577F'/>
                    </definition>
                    <application>
                        <apply toObject='CAPTION' styles='CaptionStyle'/>
                        <apply toObject='SUBCAPTION' styles='CaptionStyle'/>
                    </application>
                    </styles>
                    </chart>";
                            string tipoPeriodicidade = "";
                            #region Diarias
                            if (dreader["periodicidade"].ToString() == "D")
                            {
                                tipoPeriodicidade = "Dirio";
                                //SqlDataReader dr = Venda.LoadDataXML(dtaDe, dtaAte, CodigoLojaSessao,tipo);
                                SqlDataReader dr = DashBoard.TicketMedio(Convert.ToDateTime(dreader["dtaInicial"].ToString()), Convert.ToDateTime(dreader["dtaFinal"].ToString()), "D", CodigoLojaSessao);
                                while (dr.Read())
                                {
                                    categories += "<category label='" + Convert.ToDateTime(dr["tempo"].ToString()).ToString("dd/MM") + "'/>";
                                    //ListDias.Add(Convert.ToDateTime(dr["tempo"].ToString()).ToString("dd/MM"));
                                    valor = Convert.ToDecimal(dr[0].ToString()).ToString("N2").Replace(",", "").Replace(".", "");
                                    dataSet += "<set value='" + valor.Substring(0, valor.Length - 2) + "." + valor.Substring(valor.Length - 2) + "'/>";
                                    dataSet2 += "<set value='0'/>";
                                }
                                dr.Close();
                            }
                            #endregion

                            #region Mensais
                            if (dreader["periodicidade"].ToString() == "M")
                            {
                                tipoPeriodicidade = "Mensal";
                                SqlDataReader dr = DashBoard.TicketMedio(Convert.ToDateTime(dreader["dtaInicial"].ToString()), Convert.ToDateTime(dreader["dtaFinal"].ToString()), "M",CodigoLojaSessao);
                                while (dr.Read())
                                {
                                    categories += "<category label='" + Convert.ToDateTime(dr["tempo"].ToString()).ToString("MM/yyyy") + "'/>";
                                    valor = Convert.ToDecimal(dr[0].ToString()).ToString("N2").Replace(",", "").Replace(".", "");
                                    dataSet += "<set value='" + valor.Substring(0, valor.Length - 2) + "." + valor.Substring(valor.Length - 2) + "'/>";
                                    dataSet2 += "<set value='0'/>";
                                }
                                dr.Close();
                            }
                            #endregion

                            #region Anuais
                            if (dreader["periodicidade"].ToString() == "A")
                            {
                                tipoPeriodicidade = "Anual";
                                SqlDataReader dr = DashBoard.TicketMedio(Convert.ToDateTime(dreader["dtaInicial"].ToString()), Convert.ToDateTime(dreader["dtaFinal"].ToString()), "A", CodigoLojaSessao);
                                while (dr.Read())
                                {
                                    categories += "<category label='" + dr["tempo"].ToString() + "'/>";
                                    valor = Convert.ToDecimal(dr[0].ToString()).ToString("N2").Replace(",", "").Replace(".", "");
                                    dataSet += "<set value='" + valor.Substring(0, valor.Length - 2) + "." + valor.Substring(valor.Length - 2) + "'/>";
                                    dataSet2 += "<set value='0'/>";
                                }
                                dr.Close();
                            }
                            #endregion

                            dataSet += "</dataSet>";
                            dataSet2 += "</dataSet>";
                            categories += "</categories>";
                            string strxml3 = "";
                            if (ddlGrafico.SelectedValue.Contains("Colu"))//Se for coluna
                                strxml3 = cabecalho + categories + dataSet + dataSet2 + rodape;
                            else
                                strxml3 = cabecalho + categories + dataSet + rodape;
                            #endregion

                            DataRow drow = Tabela.NewRow();
                            drow["Index"] = Tabela.Rows.Count;
                            drow["Xml"] = strxml3;
                            drow["Chart"] = "Fusion/" + dreader["tipoGrafico"].ToString() + ".swf";
                            drow["Nome"] = "Tiquet mdio " + tipoPeriodicidade + " de " + Convert.ToDateTime(dreader["dtaInicial"].ToString()).ToString("dd/MM/yyyy") + "  " + Convert.ToDateTime(dreader["dtaFinal"].ToString()).ToString("dd/MM/yyyy") + ".";
                            drow["codigoDashBoard"] = dreader["codigoDashBord"].ToString();
                            Tabela.Rows.Add(drow);
                        }
                        else if (dreader["funcao"].ToString() == "M")//Meta de Venda
                        {
                            #region xml de Ponteiro
                            string valor = DashBoard.Meta(Convert.ToDateTime(dreader["dtaInicial"].ToString()), Convert.ToDateTime(dreader["dtaFinal"].ToString()), CodigoLojaSessao); //txtMin.Text;//Vem do Banco
                            string meta = dreader["vlrMax"].ToString();
                            Decimal metaValor = Convert.ToDecimal(meta.Replace(".", ","));
                            string medio = Convert.ToDecimal(metaValor / 2).ToString("n2").Replace(",", "").Replace(".", "");
                            medio = dreader["vlrMin"].ToString();
                            //o Maximo do Medidor  igual a meta mais 50 % dela
                            string max = Convert.ToDecimal(metaValor + (metaValor / 2)).ToString("n2").Replace(",", "").Replace(".", "");
                            max = max.Substring(0, max.Length - 2) + "." + max.Substring(max.Length - 2);
                            string strxml1 = @"<Chart 
                    bgColor='F5F5F5' 
                    showBorder='0'
                    upperLimit='" + max + @"'
                    lowerLimit='0' 
                    baseFontColor='FFFFFF' 
                    majorTMNumber='5' 
                    majorTMColor='FFFFFF' 
                    majorTMHeight='8' 
                    minorTMNumber='5'
                    numberPrefix='R$ ' 
                    minorTMColor='FFFFFF' 
                    minorTMHeight='3' 
                    toolTipBorderColor='FFFFFF' 
                    toolTipBgColor='333333' 
                    gaugeOuterRadius='100' 
                    gaugeOriginX='170' 
                    gaugeOriginY='125' 
                    gaugeScaleAngle='270' 
                    placeValuesInside='1' 
                    gaugeInnerRadius='80%25' 
                    annRenderDelay='0' 
                    gaugeFillMix='' pivotRadius='10' 
                    showPivotBorder='0' 
                    pivotFillMix='{CCCCCC},{333333}' 
                    pivotFillRatio='50,50' showShadow='0'>
                    <colorRange>
	                    <color minValue='0' maxValue='" + medio + @"' code='B80000' alpha='70'/> 
	                    <color minValue='" + medio + @"' maxValue='" + meta + @"' code='FFCC33' alpha='70'/>
	                    <color minValue='" + meta + @"' maxValue='" + max + @"' code='008200' alpha='70'/>
                    </colorRange>
                    <dials>
                        <dial value='" + valor + @"' borderColor='FFFFFF' bgColor='000000,CCCCCC,000000' borderAlpha='0' baseWidth='10'/>
                    </dials>
                    <annotations>
                        <annotationGroup xPos='170' yPos='125' showBelow='1'>
                            <annotation type='circle' xPos='0' yPos='0' radius='115' startAngle='0' endAngle='360' fillColor='CCCCCC,111111' fillPattern='linear' fillAlpha='100,100' fillRatio='50,50' fillAngle='-45'/>
                            <annotation type='circle' xPos='0' yPos='0' radius='110' startAngle='0' endAngle='360' color='666666'/>
                        </annotationGroup>
                    </annotations>
                <customObjects>
	                <!-- Draw the background with different colors arc -->
	                <objectGroup xPos='170' yPos='125'>
		                <object type='circle' xPos='0' yPos='2.5' radius='100' startAngle='0' endAngle='360' fillPattern='linear' fillAsGradient='1' fillColor='dddddd,666666' fillAlpha='100,100'  fillRatio='50,50' fillDegree='0' showBorder='1' borderColor='444444' borderThickness='2'/>
		                <object type='circle' xPos='0' yPos='0' radius='96' startAngle='0' endAngle='360' fillPattern='linear' fillAsGradient='1' fillColor='666666,ffffff' fillAlpha='100,100'  fillRatio='50,50' fillDegree='0' />
	                </objectGroup>
                </customObjects>
                    </Chart>";
                            #endregion
                            DataRow dr = Tabela.NewRow();
                            dr["Index"] = Tabela.Rows.Count;
                            dr["Xml"] = strxml1;
                            dr["Chart"] = "Fusion/AngularGauge.swf";
                            dr["Nome"] = "Meta de Vendas de " + Convert.ToDateTime(dreader["dtaInicial"].ToString()).ToString("dd/MM/yyyy") + "  " + Convert.ToDateTime(dreader["dtaFinal"].ToString()).ToString("dd/MM/yyyy") + ".";
                            dr["codigoDashBoard"] = dreader["codigoDashBord"].ToString();
                            Tabela.Rows.Add(dr);
                        }
                    }
                    dreader.Close();
                    carregaGrid();
                    #endregion
                }
                catch
                {
                }
            }
        }
        lblError.Text= "";
    }
    #endregion

    #region Xml1
    private string Xml1()
    {
        return @"<chart caption='Comparao de Vendas por Ano' XAxisName='Year' palette='2' animation='1' subcaption='Click Aqui!' formatNumberScale='0' numberPrefix='$' showValues='0' seriesNameInToolTip='0'>
                    <categories>
                        <category label='1994'/>
                        <category label='1995'/>
                        <category label='1996'/>
                    </categories>
                <dataset seriesname='Revenue'>
                    <set value='219702' />
                    <set value='682796' />
                    <set value='547248' />
                </dataset>
                <dataset seriesName='Units Sold' parentYAxis='S'>
                    <set value='7381'/>
                    <set value='25007'/>
                    <set value='18929'/>
                </dataset>
                    <styles>
                        <definition>
                            <style type='font' color='666666' name='CaptionFont' size='15' />
                            <style type='font' name='SubCaptionFont' bold='0' />
                        </definition>
                        <application>
                            <apply toObject='caption' styles='CaptionFont' />
                            <apply toObject='SubCaption' styles='SubCaptionFont' />
                        </application>
                    </styles>
                </chart>";
    }
    #endregion

    #region ddlFunction_SelectedIndexChanged
    protected void ddlFunction_SelectedIndexChanged(object sender, EventArgs e)
    {
        //carregaGrid();
        if (ddlFunction.SelectedValue == "M")
        {
            ddlGrafico.Items.Clear();
            divPeriodo.Visible = true;
            divTiquet.Visible = false;
            divMeta.Visible = true;
            ddlGrafico.Items.Insert(0, new ListItem("Ponteiro", "P"));
            ddlGrafico.Items.Insert(0,new ListItem("", ""));
        }
        else if (ddlFunction.SelectedValue == "T")
        {
            ddlGrafico.Items.Clear();
            divPeriodo.Visible = true;
            divTiquet.Visible = true;
            divMeta.Visible = false;
            ddlGrafico.Items.Insert(0, new ListItem("Linha", "ScrollLine2D"));
            ddlGrafico.Items.Insert(0, new ListItem("Coluna", "ScrollColumn2D"));
            ddlGrafico.Items.Insert(0, new ListItem("", ""));
        }
        else
        {
            ddlGrafico.Items.Clear();
            divPeriodo.Visible = false;
            divTiquet.Visible = false;
            divMeta.Visible = false;
        }
    }
    #endregion

    #region carregaRow
    private void carregaRow()
    {
        DataRow dr = Tabela.NewRow();
        dr["Index"] = Tabela.Rows.Count;
        Tabela.Rows.Add(dr);
    }
    #endregion

    #region carregaGrid
    private void carregaGrid()
    {
        dtlGraficos.DataSource = Tabela;
        dtlGraficos.DataBind();
        foreach(DataRow row in Tabela.Rows)
        {
            dtlGraficos.Items[Convert.ToInt32(row["Index"].ToString())].Controls.Add(moldura(row["Chart"].ToString(), row["Xml"].ToString(), row["Index"].ToString(), row["Nome"].ToString()));
        }
        upDataList.Update();
    }
    #endregion

    #region Moldura
    private Literal moldura(string charts, string strXml, string index, string nome)
    {
        Literal li = new Literal();
        li.Text = @"<table cellpadding='0' cellspacing='0'border='0' width='356px'>
            <tr>
                <td bgcolor='black'>
                    <img src='./Imagens/EsqAzul.bmp'/>
                </td>
                <td style='color:White;background-image: url(Imagens/MeioAzul.bmp);' width='350px' bgcolor='black'>
                <center><b>"+ nome +@"</b></center>
                </td>
                <td style='color:Red;' bgcolor='black'>
                <a  >
                        <img style='cursor: pointer; cursor: hand;' src='./Imagens/DirAzul.bmp' onclick='javaScript:deletar("+index.ToString()+@");' title='Deletar Grfico' /></a>
                </td>
            </tr>
            <tr>
                <td colspan='3' bgcolor='black' Style='vertical-align:text-top;' style='height: 253px'>
                    <center>
                    " + FusionCharts.RenderChartHTML(charts, "", strXml, "NewChart", "350", "250", false) + @"
                </center>
                </td>
            </tr>
        </table>";
        return li;
    }
    #endregion

    #region btlDeletarG_Click
    protected void btlDeletarG_Click(object sender, EventArgs e)
    {
        try
        {
            if (txtIndexDel.Text != "")
            {
                foreach (DataRow row in Tabela.Rows)
                {
                    if (txtIndexDel.Text == row["Index"].ToString())
                    {
                        //row.Delete();
                        DashBoard.Delete(Convert.ToInt32(row["codigoDashBoard"].ToString()));
                        Tabela.Rows.Remove(row);
                        break;
                    }
                }
                txtIndexDel.Text = "";
                int i = 0;
                foreach (DataRow row in Tabela.Rows)
                {
                    row["Index"] = i;
                    i++;
                }
                carregaGrid();
            }
        }
        catch
        {
        }
    }
    #endregion

    #region btnGerar_Click
    protected void btnGerar_Click(object sender, ImageClickEventArgs e)
    {
        try
        {
            //dtlGraficos.Items[0].Controls.Add(moldura("Fusion/ScrollLine2D.swf", strxml3, Tabela.Rows.Count.ToString()));
            DashBoard dashBoard = new DashBoard();
            dashBoard.DtaInicial = cldDe.Data;
            dashBoard.DtaFinal = cldAte.Data;
            dashBoard.CodigoLoj = CodigoLojaSessao;
            if (cldAte.Data > cldDe.Data)
            {
                if (ddlFunction.SelectedValue == "T")//Tiquet Mdio
                {
                    #region xml de Tiquet
                    string cabecalho = @"<chart bgColor='FFFFFF' 
                showBorder='0' 
                showvalues='0' 
                caption='Ticket Mdio' 
                decimalprecision='2' 
                palette='3' numberPreffix='R$ '
                useRoundEdges='0'>";
                    string categories = "<categories>";
                    string dataSet = "<dataSet >";
                    string dataSet2 = "<dataSet >";
                    string valor = "";//Auxiliar
                    string rodape = @"<styles>
                    <definition>
                        <style name='CaptionStyle' type='font' font='Arial' size='16' color='00577F'/>
                    </definition>
                    <application>
                        <apply toObject='CAPTION' styles='CaptionStyle'/>
                        <apply toObject='SUBCAPTION' styles='CaptionStyle'/>
                    </application>
                    </styles>
                    </chart>";
                    #region Diarias
                    if (rblTiqt.SelectedValue == "D")
                    {
                        dashBoard.Periodicidade = 'D';
                        //SqlDataReader dr = Venda.LoadDataXML(dtaDe, dtaAte, CodigoLojaSessao,tipo);
                        SqlDataReader dr = DashBoard.TicketMedio(cldDe.Data, cldAte.Data, rblTiqt.SelectedValue, CodigoLojaSessao);
                        while (dr.Read())
                        {
                            categories += "<category label='" + Convert.ToDateTime(dr["tempo"].ToString()).ToString("dd/MM") + "'/>";
                            //ListDias.Add(Convert.ToDateTime(dr["tempo"].ToString()).ToString("dd/MM"));
                            valor = Convert.ToDecimal(dr[0].ToString()).ToString("N2").Replace(",", "").Replace(".", "");
                            dataSet += "<set value='" + valor.Substring(0, valor.Length - 2) + "." + valor.Substring(valor.Length - 2) + "'/>";
                            dataSet2 += "<set value='0'/>";
                        }
                        dr.Close();
                    }
                    #endregion

                    #region Mensais
                    if (rblTiqt.SelectedValue == "M")
                    {
                        dashBoard.Periodicidade = 'M';
                        SqlDataReader dr = DashBoard.TicketMedio(cldDe.Data, cldAte.Data, rblTiqt.SelectedValue, CodigoLojaSessao);
                        while (dr.Read())
                        {
                            categories += "<category label='" + Convert.ToDateTime(dr["tempo"].ToString()).ToString("MM/yyyy") + "'/>";
                            valor = Convert.ToDecimal(dr[0].ToString()).ToString("N2").Replace(",", "").Replace(".", "");
                            dataSet += "<set value='" + valor.Substring(0, valor.Length - 2) + "." + valor.Substring(valor.Length - 2) + "'/>";
                            dataSet2 += "<set value='0'/>";
                        }
                        dr.Close();
                    }
                    #endregion


                    #region Mensais
                    if (rblTiqt.SelectedValue == "A")
                    {
                        dashBoard.Periodicidade = 'A';
                        SqlDataReader dr = DashBoard.TicketMedio(cldDe.Data, cldAte.Data, rblTiqt.SelectedValue, CodigoLojaSessao);
                        while (dr.Read())
                        {
                            categories += "<category label='" + dr["tempo"].ToString() + "'/>";
                            valor = Convert.ToDecimal(dr[0].ToString()).ToString("N2").Replace(",", "").Replace(".", "");
                            dataSet += "<set value='" + valor.Substring(0, valor.Length - 2) + "." + valor.Substring(valor.Length - 2) + "'/>";
                            dataSet2 += "<set value='0'/>";
                        }
                        dr.Close();
                    }
                    #endregion

                    dataSet += "</dataSet>";
                    dataSet2 += "</dataSet>";
                    categories += "</categories>";
                    string strxml3 = "";
                    if (ddlGrafico.SelectedValue.Contains("Colu"))//Se for coluna
                        strxml3 = cabecalho + categories + dataSet + dataSet2 + rodape;
                    else
                        strxml3 = cabecalho + categories + dataSet + rodape;
                    #endregion

                    DataRow drow = Tabela.NewRow();
                    drow["Index"] = Tabela.Rows.Count;
                    drow["Xml"] = strxml3;
                    drow["Chart"] = "Fusion/" + ddlGrafico.SelectedValue + ".swf";
                    drow["Nome"] = "Tiquet mdio " + rblTiqt.Text + " de " + cldDe.TextBoxCalendario.Text + "  " + cldAte.TextBoxCalendario.Text + ".";
                    Tabela.Rows.Add(drow);
                    dashBoard.Funcao = 'T';
                    dashBoard.TipoGrafico = ddlGrafico.SelectedValue;
                }
                else if (ddlFunction.SelectedValue == "M")//Meta de Venda
                {
                    #region xml de Ponteiro
                    string valor = DashBoard.Meta(cldDe.Data, cldAte.Data,CodigoLojaSessao); //txtMin.Text;//Vem do Banco
                    string meta = ucvMax.TxtValor.Text.Replace(",", "").Replace(".", "");
                    Decimal metaValor = ucvMax.Valor;
                    string medio = Convert.ToDecimal(metaValor / 2).ToString("n2").Replace(",", "").Replace(".", "");
                    medio = ucvMin.TxtValor.Text.Replace(",", "").Replace(".", "");
                    //o Maximo do Medidor  igual a meta mais 50 % dela
                    string max = Convert.ToDecimal(metaValor + (metaValor / 2)).ToString("n2").Replace(",", "").Replace(".", "");
                    max = max.Substring(0, max.Length - 2) + "." + max.Substring(max.Length - 2);
                    string strxml1 = @"<Chart 
                    bgColor='F5F5F5' 
                    showBorder='0'
                    upperLimit='" + max + @"'
                    lowerLimit='0' 
                    baseFontColor='FFFFFF' 
                    majorTMNumber='5' 
                    majorTMColor='FFFFFF' 
                    majorTMHeight='8' 
                    minorTMNumber='5'
                    numberPrefix='R$ ' 
                    minorTMColor='FFFFFF' 
                    minorTMHeight='3' 
                    toolTipBorderColor='FFFFFF' 
                    toolTipBgColor='333333' 
                    gaugeOuterRadius='100' 
                    gaugeOriginX='170' 
                    gaugeOriginY='125' 
                    gaugeScaleAngle='270' 
                    placeValuesInside='1' 
                    gaugeInnerRadius='80%25' 
                    annRenderDelay='0' 
                    gaugeFillMix='' pivotRadius='10' 
                    showPivotBorder='0' 
                    pivotFillMix='{CCCCCC},{333333}' 
                    pivotFillRatio='50,50' showShadow='0'>
                    <colorRange>
	                    <color minValue='0' maxValue='" + medio + @"' code='B80000' alpha='70'/> 
	                    <color minValue='" + medio + @"' maxValue='" + meta + @"' code='FFCC33' alpha='70'/>
	                    <color minValue='" + meta + @"' maxValue='" + max + @"' code='008200' alpha='70'/>
                    </colorRange>
                    <dials>
                        <dial value='" + valor + @"' borderColor='FFFFFF' bgColor='000000,CCCCCC,000000' borderAlpha='0' baseWidth='10'/>
                    </dials>
                    <annotations>
                        <annotationGroup xPos='170' yPos='125' showBelow='1'>
                            <annotation type='circle' xPos='0' yPos='0' radius='115' startAngle='0' endAngle='360' fillColor='CCCCCC,111111' fillPattern='linear' fillAlpha='100,100' fillRatio='50,50' fillAngle='-45'/>
                            <annotation type='circle' xPos='0' yPos='0' radius='110' startAngle='0' endAngle='360' color='666666'/>
                        </annotationGroup>
                    </annotations>
                <customObjects>
	                <!-- Draw the background with different colors arc -->
	                <objectGroup xPos='170' yPos='125'>
		                <object type='circle' xPos='0' yPos='2.5' radius='100' startAngle='0' endAngle='360' fillPattern='linear' fillAsGradient='1' fillColor='dddddd,666666' fillAlpha='100,100'  fillRatio='50,50' fillDegree='0' showBorder='1' borderColor='444444' borderThickness='2'/>
		                <object type='circle' xPos='0' yPos='0' radius='96' startAngle='0' endAngle='360' fillPattern='linear' fillAsGradient='1' fillColor='666666,ffffff' fillAlpha='100,100'  fillRatio='50,50' fillDegree='0' />
	                </objectGroup>
                </customObjects>
                    </Chart>";
                    #endregion
                    DataRow dr = Tabela.NewRow();
                    dr["Index"] = Tabela.Rows.Count;
                    dr["Xml"] = strxml1;
                    dr["Chart"] = "Fusion/AngularGauge.swf";
                    dr["Nome"] = "Meta de Vendas de " + cldDe.TextBoxCalendario.Text + "  " + cldAte.TextBoxCalendario.Text + ".";
                    Tabela.Rows.Add(dr);
                    dashBoard.VlrMax = (double?)(ucvMax.Valor);
                    dashBoard.VlrMin = (double?)(ucvMin.Valor);
                    dashBoard.Funcao = 'M';
                    dashBoard.TipoGrafico = ddlGrafico.SelectedValue;
                }
                carregaGrid();
                dashBoard.Save();
                Tabela.Rows[Tabela.Rows.Count - 1]["codigoDashBoard"] = dashBoard.CodigoDashBoard;
            }
            else
            {
                lblError.Text = @"Data ""de"" no pode ser maior que a ""at""";
            }
        }
        catch
        {
            lblError.Text = "Falha de comunicao com o Banco de Dados. Tente novamente mais tarde.";
        }
    }
    #endregion
}
