using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using DcartesClassLibrary;

// Autor Jesiel Sopzak Campos
// MasterPage Padro, utilizada como base para as demais MasterPages

public partial class Sistema_MasterPage_Padrao : System.Web.UI.MasterPage
{
    #region Propriedades

    #region TelaCorrente
    /// <summary>
    /// Retorna o handle da Tela Corrente
    /// </summary>
    protected Sistema_Template_TelaPadrao TelaCorrente
    {
        get
        {
            return ((Sistema_Template_TelaPadrao)(this.Page));
        }
    }
    #endregion

    #endregion

    #region Eventos

    #region Page_Init
    /// <summary>
    /// Rotina para alterar o nome da tela, de acordo com a opo selecionada de menu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected virtual void Page_Init(object sender, EventArgs e)
    {
        ((Label)(Page.Master.FindControl("form1").FindControl("lblTituloTela"))).Text = TelaCorrente.NomeTelaMenuSessao;
    }
    #endregion

    #region Page_Load
    /// <summary>
    /// Rotina de PageLoad da tela, replicada para todas as demais telas como herana. 
    /// Caso seja necessrio utilizar o mtido Page_Load nas telas, ento ele dever ser 
    /// sobreposto mas chamando a rotina das telas anteries (base.Page_Load).
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected virtual void Page_Load(object sender, EventArgs e) 
    {
        //TelaCorrente.GravarSucesso = true;
        PageLoadMasterPage();  
        TelaCorrente.PageLoadTemplate();
    }
    #endregion

    #endregion

    #region Metodos Virtuais para serem Sobrescritos

    #region ExecucarAcaoValidaAcesso
    public virtual void ExecucarAcaoValidaAcesso(TipoAcesso tpAcesso)
    { }
    #endregion
    
    #region PageLoadMasterPage
    public virtual void PageLoadMasterPage()
    {
    }
    #endregion

    #endregion

}
