using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using DcartesClassLibrary;

// Autor: Jesiel Sopzak Campos
// Tela Padro, utilizada como base para os demais templates de tela

public partial class Sistema_Template_TelaPadrao : System.Web.UI.Page
{

    #region Propriedades Gerais do Framework

    #region GravarSucesso
    public bool GravarSucesso
    {
        get
        {
            if (ViewState["GravaSucesso"] != null)
            {
                return Convert.ToBoolean(ViewState["GravaSucesso"].ToString());
            }
            else
            {
                ViewState.Add("GravaSucesso", true);
                return Convert.ToBoolean(ViewState["GravaSucesso"].ToString());
            }
        }
        set
        {
            ViewState.Add("GravaSucesso", value);
        }
    }
    #endregion

    #region CodigoChave
    /// <summary>
    /// Armazena o Codigo Chave da Tela atravs do ViewState.
    /// O valor entre as telas de consulta e manuteno  atravs de sesso, mas depois na tela 
    /// de manuteno  atribuido ao viewstate.
    /// </summary>
    public int CodigoChave
    {
        get
        {
            if (ViewState["codChave"] != null)
            {
                return Convert.ToInt32(ViewState["codChave"].ToString());
            }
            else
            {
                ViewState.Add("codChave", 0);
                return Convert.ToInt32(ViewState["codChave"].ToString());
            }
        }
        set
        {
            ViewState.Add("codChave", value);
        }
    }
    #endregion

    #region NomeLoginSessao
    ///// <summary>
    ///// Retorna o Login do Usuario, obtido atravs da varivel de sesso
    ///// </summary>
    //public string NomeLoginSessao
    //{
    //    get
    //    {
    //        if (Session["vslogin015"] != null)
    //        {
    //            return Session["vslogin015"].ToString();
    //        }
    //        else
    //        {
    //            Response.Redirect(NomeTelaAviso + "?erro=2&msg=" + "Sua sesso expirou.");
    //            return "0";
    //        }
    //    }
    //}
    #endregion

    #region CodigoUsuarioSessao
    ///// <summary>
    ///// Retorna o Codigo do Usuario, obtido atravs da varivel de sesso
    ///// </summary>
    //public int CodigoUsuarioSessao
    //{
    //    get
    //    {
    //        if (Session["vscodUsuario025"] != null)
    //        {
    //            return Convert.ToInt32(Session["vscodUsuario025"].ToString());
    //        }
    //        else
    //        {
    //            Response.Redirect(NomeTelaAviso + "?erro=2&msg=" + "Sua sesso expirou.");
    //            return 0;
    //        }
    //    }
    //}
    #endregion

    #region CodigoContatoSessao
    ///// <summary>
    ///// Retorna o Codigo do Contato, obtido atravs da varivel de sesso
    ///// </summary>
    //public int CodigoContatoSessao
    //{
    //    get
    //    {
    //        if (Session["vscodContato013"] != null)
    //        {
    //            return Convert.ToInt32(Session["vscodContato013"].ToString());
    //        }
    //        else
    //        {
    //            Response.Redirect(NomeTelaAviso + "?erro=2&msg=" + "Sua sesso expirou.");
    //            return 0;
    //        }
    //    }
    //}
    #endregion

    #region NomeContatoSessao
    ///// <summary>
    ///// Retorna o Nome do Contato, obtido atravs da varivel de sesso
    ///// </summary>
    //public string NomeContatoSessao
    //{
    //    get
    //    {
    //        if (Session["vsnome013"] != null)
    //        {
    //            return Session["vsnome013"].ToString();
    //        }
    //        else
    //        {
    //            Response.Redirect(NomeTelaAviso + "?erro=2&msg=" + "Sua sesso expirou.");
    //            return "0";
    //        }
    //    }
    //}
    #endregion

    #region CodigoSiteSessao
    ///// <summary>
    ///// Retorna o Codigo do Site, obtido atravs da varivel de sesso
    ///// </summary>
    //public int CodigoSiteSessao
    //{
    //    get
    //    {
    //        if (Session["vscodSite006"] != null)
    //        {
    //            return Convert.ToInt32(Session["vscodSite006"].ToString());
    //        }
    //        else
    //        {
    //            Response.Redirect(NomeTelaAviso + "?erro=2&msg=" + "Sua sesso expirou.");
    //            return 0;
    //        }
    //    }
    //}
    #endregion

    #region CodigoChaveSessao
    /// <summary>
    /// Retorna o Codigo da Chave da Tela de Consulta, obtido atravs da varivel de sesso
    /// </summary>
    public int CodigoChaveSessao
    {
        get
        {
            if (Session["vscodChave"] != null)
            {
                return Convert.ToInt32(Session["vscodChave"].ToString());
            }
            else
            {
                return -1;
            }
        }
    }
    #endregion

    #region ImagemSessao
    //public FileUpload ImagemSessao
    //{
    //    get
    //    { return (FileUpload)(Session["vsimagem"]); }
    //}
    #endregion

    #region NomeModulo
    ///// <summary>
    ///// Retorna o modulo, obtido atravs da varivel de sesso
    ///// </summary>
    //public string NomeModulo
    //{
    //    get
    //    {
    //        if (Session["vsmodulo"] != null)
    //        {
    //            return Session["vsmodulo"].ToString();
    //        }
    //        else
    //        {
    //            Response.Redirect(NomeTelaAviso + "?erro=2&msg=" + "Sua sesso expirou.");
    //            return "0";
    //        }
    //    }
    //}
    #endregion

    #region NomeTelaMenuSessao
    ///// <summary>
    ///// Retorna o nome da tela selecionada, obtido atravs da varivel de sesso
    ///// </summary>
    public string NomeTelaMenuSessao
    {
        get
        {
            if (Session["vsnomeTela"] != null)
            {
                return Session["vsnomeTela"].ToString();
            }
            else
            {
                //Response.Redirect(NomeTelaAviso + "?erro=2&msg=" + "Sua sesso expirou.");
                return "";
            }
        }
    }
    #endregion

    #region NomeArquivoTelaAtual
    /// <summary>
    /// Retorna o nome da pgina Atual.
    /// Caso seja secessrio deve-se reescrever o metodo na tela.
    /// </summary>
    public virtual string NomeArquivoTelaAtual
    {
        get
        {
            string nomeTelaAtual = Page.Request.CurrentExecutionFilePath.Remove(0, Page.Request.CurrentExecutionFilePath.LastIndexOf("/") + 1);
            return nomeTelaAtual;
        }
    }
    #endregion

    #region NomeArquivoValidaAcesso
    ///// <summary>
    ///// Retorna a pgina Atual.
    ///// Caso seja secessrio reescreva a varivel na tela.
    ///// </summary>
    //public virtual string NomeArquivoValidaAcesso
    //{
    //    get
    //    {
    //        string nomeTelaAtual = Page.Request.CurrentExecutionFilePath.Remove(0, Page.Request.CurrentExecutionFilePath.LastIndexOf("/") + 1);
    //        return nomeTelaAtual;
    //    }
    //}
    #endregion

    #region NomeTelaAviso
    /// <summary>
    /// Retorna um string com o nome da pagina de Aviso.
    /// </summary>
    public virtual string NomeTelaAviso
    {
        get
        {
            return "~/Aviso.aspx";
        }
    }
    #endregion    

    #region CodigoAreaSessao
    ///// <summary>
    ///// Retorna o Codigo da rea que esta na Sesso
    ///// </summary>
    //public int CodigoAreaSessao
    //{
    //    get
    //    {
    //        if (Session["Area"] != null)
    //        {
    //            return Convert.ToInt32(Session["Area"]);
    //        }
    //        else
    //        {
    //            return 0;
    //        }
    //    }
    //    set
    //    {
    //        Session.Add("Area",value);
    //    }
    //}
    #endregion

    #region CodigoLojaSessao
    /// <summary>
    /// Retorna o Codigo da Loja que esta na Sesso
    /// </summary>
    public int CodigoLojaSessao
    {
        get
        {
            if (Session["codLoja"] != null)
            {
                return Convert.ToInt32(Session["codLoja"]);
            }
            else
            {
               return 0;
            }
        }
        set
        {
            Session.Add("codLoja", value);
        }
    }
    #endregion

    #endregion

    #region Mtodos

    #region LimparCampos
    /// <summary>
    /// Limpa todos os campos da tela. 
    /// </summary>
    public virtual void LimparCampos(Control page)
    {
        foreach (Control ctrl in page.Controls)
        {
            if (ctrl is UpdatePanel)
            {
                LimpaCamposUDPanel(ctrl);
            }
            else if (ctrl is TextBox)
            {
                ((TextBox)(ctrl)).Text = "";
            }
            else if (ctrl is CheckBox)
            {
                ((CheckBox)(ctrl)).Checked = false;
            }
            else if (ctrl is CheckBoxList)
            {
                //TODO: falta validar no limpar campos o CheckBoxList
                //((CheckBoxList)(ctrl))
            }
            else if (ctrl is DropDownList)
            {
                ((DropDownList)(ctrl)).SelectedIndex = (((DropDownList)(ctrl)).Items.Count - 1);
                if (((DropDownList)(ctrl)).Items.Count > 0)
                {
                    ((DropDownList)(ctrl)).SelectedIndex = 0;
                }                
            }
            else if (ctrl is Image)
            {
                if (ctrl.ID == "imgSalvaBanco")
                {
                    ((Image)(ctrl)).ImageUrl = "";
                    ((Image)(ctrl)).Visible = false;
                }
            }            
        }
    }
    
    public void LimpaCamposUDPanel(Control ctrl)
    {
        foreach (Control ctrlUP in ctrl.Controls)
        {
            foreach (Control componetUP in ctrlUP.Controls)
            {
                if (componetUP is UpdatePanel)
                {
                    LimpaCamposUDPanel(componetUP);
                }
                else if (componetUP is TextBox)
                {
                    ((TextBox)(componetUP)).Text = "";
                }
                else if (componetUP is CheckBox)
                {
                    ((CheckBox)(componetUP)).Checked = false;
                }
                else if (componetUP is CheckBoxList)
                {
                    //TODO: falta validar no limpar campos o CheckBoxList
                    //((CheckBoxList)(ctrl))
                }
                else if (componetUP is DropDownList)
                {
                    ((DropDownList)(componetUP)).SelectedIndex = (((DropDownList)(componetUP)).Items.Count - 1);
                    if (((DropDownList)(componetUP)).Items.Count > 0)
                    {
                        ((DropDownList)(componetUP)).SelectedIndex = 0;
                    }                    
                }
                else if (componetUP is Image)
                {
                    if (componetUP.ID == "imgSalvaBanco")
                    {
                        ((Image)(componetUP)).ImageUrl = "";
                        ((Image)(componetUP)).Visible = false;
                    }
                }
            }
        }
    }
    
    #endregion

    #region DefinirMascara
    /// <summary>
    /// Metodo para definir a mascara de campos nos formularios.
    /// O controle  feito atravs de JavaScript que sero adicionados automaticamente na tela.
    /// </summary>
    /// <param name="controle">Passar como parametro o nome do campo</param>
    /// <param name="mascara">Informar o tipo da mascara: NUMERO, VALOR, ...</param>
    public void DefinirMascara(WebControl controle, TipoMascara mascara)
    {
        if (!IsPostBack)
        {
            // Adicionando o script de controle de mascaras na tela
            ClientScript.RegisterClientScriptBlock(this.GetType(), "Mascaras", JavaScriptMascaras.Mascaras(), true);

            controle.Attributes.Add("OnKeyPress", "return( Mascaras(this.id,'" + mascara + "', event) )");
        }
    }
    #endregion

    #endregion
    
    #region Mtodos Virtuais

    #region PageLoadTemplate
    public virtual void PageLoadTemplate()
    {
    }
    #endregion

    #endregion


}
