using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Globalization;

// Web User Control Calendrio Padro
// Autor: Jesiel Sopzak Campos - Esfera Informtica
// Data: 19/10/2007

public partial class Sistema_UserControl_Calendario : System.Web.UI.UserControl
{
    #region Propriedades

    #region Data
    /// <summary>
    /// Seta e retorna a Data do User control
    /// </summary>
    public DateTime Data
    {
        get
        {
            try
            {
                IFormatProvider culture = new CultureInfo("pt-BR", true);
                return Convert.ToDateTime(txtCalendario.Text, culture);
            }
            catch
            {
                return Convert.ToDateTime("1/1/2000");
            }
        }
        set
        {
            try
            {
                ViewState.Add("Data", value.ToString("dd/MM/yyyy"));
                txtCalendario.Text = value.ToString("dd/MM/yyyy");
                upUserControlCalendario.Update();
            }
            catch
            {
            }
            //upUserControlCalendario.Update();
        }
    }
    #endregion

    #region Obrigatorio
    /// <summary>
    /// Caso este campo seja obrigatrio
    /// </summary>
    public bool Obrigatorio
    {
        get
        {
            return rfvData.Enabled;
        }
        set
        {
            try
            {
                ViewState.Add("Obrigatorio", value);
            }
            catch
            {
            }
        }
    }
    #endregion

    #region TextBoxCalendario
    public TextBox TextBoxCalendario
    {
        get
        {
            return txtCalendario;
        }
        set
        {
            txtCalendario = value;
        }
    }
    #endregion

    #region BtiCalendario
    public Image BtiCalendario
    {
        get
        {
            return btiCalendario;
        }
        set
        {
            btiCalendario = value;
        }
    }
    #endregion

    #region BtiCalendarioFalso
    public Image BtiCalendarioFalso
    {
        get
        {
            return btiCalendario2;
        }
        set
        {
            btiCalendario2 = value;
        }
    }
    #endregion

    #region ObrigatorioInicial

    /// <summary>

    /// Caso este campo seja obrigatrio

    /// </summary>

    public bool ObrigatorioInicial
    {

        get
        {

            return Convert.ToBoolean(ViewState["ObrigatorioInicial"]);

        }

        set
        {

            try
            {

                ViewState.Add("ObrigatorioInicial", value);

            }

            catch
            {

            }

        }

    }

    #endregion

    #region Enabled
    public bool Enabled
    {
        get
        {
            return txtCalendario.Enabled;
        }
        set
        {
            ViewState.Add("Enabled", value);
            if (txtCalendario != null)
            {
                //Obrigatorio = value;
                //rfvData.Enabled = value;
                //Panel1.Enabled = value;
                txtCalendario.Enabled = value;
                //rfvData.Enabled = value;
                meeCalendario.Enabled = value;
                btiCalendario.Visible = value;
                btiCalendario2.Visible = !value;
                upUserControlCalendario.Update();
            }
            //btiCalendario2.Enabled = value;
            //txtCalendario.Enabled = value; 
            //txtCalendario.Enabled = value; 
            //meeCalendario.Enabled = value; 
        }
    }
    #endregion

    #endregion

    #region Page_Load
    protected void Page_Load(object sender, EventArgs e)
    {
        if (ViewState["Obrigatorio"] != null)
        {
            rfvData.Enabled = Convert.ToBoolean(ViewState["Obrigatorio"].ToString());
        }

        if (!IsPostBack)
        {
            if (ViewState["Data"] != null)
                txtCalendario.Text = ViewState["Data"].ToString();


            if (ViewState["Enabled"] != null)
            {
                bool var = Convert.ToBoolean(ViewState["Enabled"].ToString());
                txtCalendario.Enabled = var;
                txtCalendario.Enabled = var;
                btiCalendario.Enabled = var;
                btiCalendario2.Enabled = var;
                rfvData.Enabled = var;
                meeCalendario.Enabled = var;
            }
        }
        //Adicionando Scripts
        Page.ClientScript.RegisterClientScriptBlock(
                   this.GetType(), "JS",
                    @"<script type='text/javascript' language='javascript' src='Js/yahoo.js'></script>
                    <script type='text/javascript' language='javascript' src='Js/event.js' ></script>
                    <script type='text/javascript' language='javascript' src='Js/dom.js' ></script>
                    <script type='text/javascript' language='javascript' src='Js/calendar.js' ></script>");

        //Adicionando jsCalendrio
        Page.ClientScript.RegisterClientScriptBlock(
            this.GetType(),
            "abreCalendario",
            JavaScripts.jsCalendario(), true);
        Page.ClientScript.RegisterClientScriptBlock(
            this.GetType(),
            "validaData",
            JavaScripts.jsValidaData(), true);
    }
    #endregion

}
